"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var _a, _b, _c, _d, _e, _f, _g, _h;
Object.defineProperty(exports, "__esModule", { value: true });
var RouterState_1 = __importStar(require("../RouterState"));
var removeTrailingSlash = function (path) {
    if (path === void 0) { path = ''; }
    return (path[path.length - 1] === '/' ? path.slice(0, path.length - 1) : path);
};
var PATHS_DEFS = {
    VERSION: {
        path: 'GET:::/',
        uri: 'GET:::/',
        handler: jest.fn(),
    },
    LIST_USERS: {
        path: 'GET:::/users/',
        uri: 'GET:::/users/',
        handler: jest.fn(),
    },
    GET_USER_PHOTO: {
        path: 'GET:::/users/photo-:foo(\\d+).png',
        uri: 'GET:::/users/photo-123.png',
        handler: jest.fn(),
    },
    GET_USER: {
        path: 'GET:::/users/:id',
        uri: 'GET:::/users/userid',
        handler: jest.fn(),
    },
    NEW_USER: {
        path: 'POST:::/users/',
        uri: 'POST:::/users/',
        handler: jest.fn(),
    },
    UPDATE_USER: {
        path: 'PUT:::/users/',
        uri: 'PUT:::/users/',
        handler: jest.fn(),
    },
    DELETE_USER: {
        path: 'DELETE:::/users/:id',
        uri: 'DELETE:::/users/userid',
        handler: jest.fn(),
    },
    LIST_CLIENTS: {
        path: 'GET:::/users/clients/',
        uri: 'GET:::/users/clients/',
        handler: jest.fn(),
    },
    GET_CLIENT: {
        path: 'GET:::/users/clients/:id',
        uri: 'GET:::/users/clients/clientid',
        handler: jest.fn(),
    },
    NEW_CLIENT: {
        path: 'POST:::/users/clients/',
        uri: 'POST:::/users/clients/',
        handler: jest.fn(),
    },
    GET_BILL: {
        path: 'GET:::/users/clients/:id/bills/:id',
        uri: 'GET:::/users/clients/clientid/bills/billid',
        handler: jest.fn(),
    },
    GET_BILLS: {
        path: 'GET:::/users/clients/:id/bills/:from/:to',
        uri: 'GET:::/users/clients/clientid/bills/2023-03-04/2023-04-04',
        handler: jest.fn(),
    },
};
var PATH_DEFS_ENTRIES = Object.entries(PATHS_DEFS);
var arrayOfUndefinedEndpoints = [
    'POST:::/',
    'GET:::/users/clients/clientid/bills',
    'GET:::/users/userid/bills',
    'GET:::/users/clients/clientid/bills/2023-03-04/2023-04-04/itDoesNotExist/',
    'GET:::/users/clients/clientid/bills/2023-03-04/2023-04-04/itDoesNotExist/itneither',
    'POST:::/users/clients/clientid/bills/2023-03-04/2023-04-04',
    'GET:::/login',
    'GET:::/login/signup',
    'GET:::/login/signit',
    'GET:::/users/employees/employeeid/hours',
    'POST:::/users/employees/employeeid/hours',
    'PUT:::/users/employees/employeeid/hours',
];
var mockedState = {
    '/': (_a = {},
        _a[RouterState_1.MethodSymbols.get] = PATHS_DEFS.VERSION.handler,
        _a.users = (_b = {},
            _b[RouterState_1.MethodSymbols.get] = PATHS_DEFS.LIST_USERS.handler,
            _b[RouterState_1.MethodSymbols.post] = PATHS_DEFS.NEW_USER.handler,
            _b[RouterState_1.MethodSymbols.put] = PATHS_DEFS.UPDATE_USER.handler,
            _b['photo-:foo(\\d+).png'] = (_c = {},
                _c[RouterState_1.MethodSymbols.get] = PATHS_DEFS.GET_USER_PHOTO.handler,
                _c),
            _b[':id'] = (_d = {},
                _d[RouterState_1.MethodSymbols.get] = PATHS_DEFS.GET_USER.handler,
                _d[RouterState_1.MethodSymbols.delete] = PATHS_DEFS.DELETE_USER.handler,
                _d),
            _b.clients = (_e = {},
                _e[RouterState_1.MethodSymbols.post] = PATHS_DEFS.NEW_CLIENT.handler,
                _e[RouterState_1.MethodSymbols.get] = PATHS_DEFS.LIST_CLIENTS.handler,
                _e[':id'] = (_f = {
                        bills: {
                            ':id': (_g = {},
                                _g[RouterState_1.MethodSymbols.get] = PATHS_DEFS.GET_BILL.handler,
                                _g),
                            ':from': {
                                ':to': (_h = {},
                                    _h[RouterState_1.MethodSymbols.get] = PATHS_DEFS.GET_BILLS.handler,
                                    _h),
                            },
                        }
                    },
                    _f[RouterState_1.MethodSymbols.get] = PATHS_DEFS.GET_CLIENT.handler,
                    _f),
                _e),
            _b),
        _a),
};
var initTest = function () {
    PATH_DEFS_ENTRIES.forEach(function (_a) {
        var _b = __read(_a, 2), name = _b[0], handler = _b[1].handler;
        handler.mockReturnValue({ body: name });
    });
};
var testUndefinedPaths = function (router) {
    return arrayOfUndefinedEndpoints.forEach(function (path) {
        it('Should not return handler for undefined path ' + path, function () {
            var _a = __read(router.getAndReturnPath(path), 2), item = _a[0], pathToItem = _a[1];
            expect(item).toEqual(undefined);
            expect(pathToItem).toBeUndefined();
        });
    });
};
describe('list', function () {
    var router = new RouterState_1.default(mockedState);
    beforeAll(initTest);
    PATH_DEFS_ENTRIES.forEach(function (_a) {
        var _b = __read(_a, 2), name = _b[0], _c = _b[1], path = _c.path, handler = _c.handler;
        it('Should return handler for ' + path, function () {
            var _a = __read(router.getAndReturnPath(path), 2), returnedHandler = _a[0], pathToItem = _a[1];
            expect(returnedHandler).toBeDefined();
            expect(typeof returnedHandler).toEqual('function');
            expect(returnedHandler).toBe(handler);
            expect(removeTrailingSlash(pathToItem)).toEqual(removeTrailingSlash(path.split(RouterState_1.default.SEPARATOR)[1]));
            var result = handler();
            var body = result.body;
            expect(body).toEqual(name);
        });
    });
    testUndefinedPaths(router);
});
describe('insert', function () {
    var router = new RouterState_1.default();
    beforeAll(initTest);
    PATH_DEFS_ENTRIES.forEach(function (_a) {
        var _b = __read(_a, 2), name = _b[0], _c = _b[1], path = _c.path, handler = _c.handler, uri = _c.uri;
        it("Should save the path ".concat(path, " and return the handler"), function () {
            handler.mockReturnValue({ body: name });
            var value = router.insert(path, handler);
            expect(value).toBe(handler);
        });
    });
    PATH_DEFS_ENTRIES.forEach(function (_a) {
        var _b = __read(_a, 2), name = _b[0], _c = _b[1], uri = _c.uri, path = _c.path;
        it("Should the uri ".concat(uri, "  get the handler for defined path: ").concat(path), function () {
            var _a = __read(router.getAndReturnPath(uri), 2), handler = _a[0], pathToItem = _a[1];
            var result = handler();
            expect(result).toBeDefined();
            expect(result === null || result === void 0 ? void 0 : result.body).toEqual(name);
            expect(removeTrailingSlash(pathToItem)).toEqual(removeTrailingSlash(path.split(RouterState_1.default.SEPARATOR)[1]));
        });
    });
    testUndefinedPaths(router);
    it('Should the tree be equal to the expected tree root', function () {
        expect(JSON.stringify(router.getRoot())).toEqual(JSON.stringify(mockedState['/']));
    });
});
